Project Chrono: chrono::vehicle::ChVehicleCosimOtherNode Class Reference

Public Member Functions | List of all members
chrono::vehicle::ChVehicleCosimOtherNode Class Reference
VEHICLE module » Co-simulation

## Description

Definition of an additional MPI node not directly involved in co-simulation.

Such nodes can be used for distributed terrain simulation.

`#include <ChVehicleCosimOtherNode.h>`

Inheritance diagram for chrono::vehicle::ChVehicleCosimOtherNode:
[legend]
Collaboration diagram for chrono::vehicle::ChVehicleCosimOtherNode:
[legend]

## Public Member Functions
virtual NodeType | GetNodeType () const override final
| Return the node type as NodeType::TIRE.
virtual void | Synchronize (int step_number, double time) override final
| Synchronize this node.
virtual void | Advance (double step_size) override final
| Advance simulation.
virtual void | OutputData (int frame) override final
| Output logging and debugging data.
virtual void | OutputVisualizationData (int frame) override final
| Output post-processing visualization data.
virtual ChSystem * | GetSystemPostprocess () const override
| No Chrono system for post-processing export.
Public Member Functions inherited from chrono::vehicle::ChVehicleCosimBaseNode
std::string | GetNodeTypeString () const
| Return the node type as a string.
bool | IsCosimNode () const
| Return true if this node is part of the co-simulation infrastructure.
void | SetStepSize (double step)
| Set the integration step size (default: 1e-4).
double | GetStepSize () const
| Get the integration step size.
void | SetOutDir (const std::string &dir_name, const std::string &suffix="")
| Set the name of the output directory and an identifying suffix.
void | SetVerbose (bool verbose)
| Enable/disable verbose messages during simulation (default: true).
void | EnableRuntimeVisualization (double render_fps=100, bool save_img=false)
| Enable run-time visualization (default: false).
void | SetCameraPosition (const ChVector3d &cam_pos, const ChVector3d &cam_target=VNULL)
| Set camera location and target point.
void | SetCameraTracking (bool track)
| Enable/disable tracking of objects (default: true).
void | EnablePostprocessVisualization (double render_fps=100)
| Enable Blender postprocessing (default: false).
const std::string & | GetOutDirName () const
| Get the output directory name for this node.
double | GetStepExecutionTime () const
| Get the simulation execution time for the current step on this node.
double | GetTotalExecutionTime () const
| Get the cumulative simulation execution time on this node.
virtual void | Initialize ()
| Initialize this node.
virtual void | OnRender ()
| Render the current simulation frame.
void | Render (double step_size)
| Render simulation frame.
virtual void | WriteCheckpoint (const std::string &filename) const
| Write checkpoint to the specified file (which will be created in the output directory).

## Additional Inherited Members
Public Types inherited from chrono::vehicle::ChVehicleCosimBaseNode
enum class | NodeType { MBS_WHEELED , MBS_TRACKED , TERRAIN , TIRE }
| Type of node participating in co-simulation. More...
enum class | InterfaceType { BODY , MESH }
| Type of the vehicle-terrain communication interface. More...
Static Public Member Functions inherited from chrono::vehicle::ChVehicleCosimBaseNode
static std::string | OutputFilename (const std::string &dir, const std::string &root, const std::string &ext, int frame, int frame_digits)
| Utility function for creating an output file name.
Protected Member Functions inherited from chrono::vehicle::ChVehicleCosimBaseNode
| ChVehicleCosimBaseNode (const std::string &name)
void | SendGeometry (const ChVehicleGeometry &geom, int dest) const
| Utility function to pack and send a struct with geometry information.
void | RecvGeometry (ChVehicleGeometry &geom, int source) const
| Utility function to receive and unpack a struct with geometry information.
void | ProgressBar (unsigned int x, unsigned int n, unsigned int w=50)
| Utility function to display a progress bar to the terminal.
Protected Attributes inherited from chrono::vehicle::ChVehicleCosimBaseNode
int | m_rank
| MPI rank of this node (in MPI_COMM_WORLD).
double | m_step_size
| integration step size
std::string | m_name
| name of the node
std::string | m_out_dir
| top-level output directory
std::string | m_node_out_dir
| node-specific output directory
std::ofstream | m_outf
| output file stream
bool | m_renderRT
| if true, perform run-time rendering
bool | m_renderRT_all
| if true, render all frames
double | m_renderRT_step
| time step between rendered frames
bool | m_writeRT
| if true, write images to file
bool | m_renderPP
| if true, save data for post-processing
bool | m_renderPP_all
| if true, save data at all frames
double | m_renderPP_step
| time step between post-processing save frames
bool | m_track
| track objects
ChVector3d | m_cam_pos
| camera location
ChVector3d | m_cam_target
| camera target (lookat) point
unsigned int | m_num_wheeled_mbs_nodes
unsigned int | m_num_tracked_mbs_nodes
unsigned int | m_num_terrain_nodes
unsigned int | m_num_tire_nodes
ChTimer | m_timer
| timer for integration cost
double | m_cum_sim_time
| cumulative integration cost
bool | m_verbose
| verbose messages during simulation?
Static Protected Attributes inherited from chrono::vehicle::ChVehicleCosimBaseNode
static const double | m_gacc = -9.81

## Member Function Documentation

## ◆ Advance()

virtual void chrono::vehicle::ChVehicleCosimOtherNode::Advance | ( | double | step_size | ) |
| inlinefinaloverridevirtual

Advance simulation.

Implements chrono::vehicle::ChVehicleCosimBaseNode.

## ◆ GetNodeType()

virtual NodeType chrono::vehicle::ChVehicleCosimOtherNode::GetNodeType | ( |  | ) | const
| inlinefinaloverridevirtual

Return the node type as NodeType::TIRE.

Implements chrono::vehicle::ChVehicleCosimBaseNode.

## ◆ GetSystemPostprocess()

virtual ChSystem * chrono::vehicle::ChVehicleCosimOtherNode::GetSystemPostprocess | ( |  | ) | const
| inlineoverridevirtual

No Chrono system for post-processing export.

Implements chrono::vehicle::ChVehicleCosimBaseNode.

## ◆ OutputData()

virtual void chrono::vehicle::ChVehicleCosimOtherNode::OutputData | ( | int | frame | ) |
| inlinefinaloverridevirtual

Output logging and debugging data.

Implements chrono::vehicle::ChVehicleCosimBaseNode.

## ◆ OutputVisualizationData()

virtual void chrono::vehicle::ChVehicleCosimOtherNode::OutputVisualizationData | ( | int | frame | ) |
| inlinefinaloverridevirtual

Output post-processing visualization data.

Implements chrono::vehicle::ChVehicleCosimBaseNode.

## ◆ Synchronize()

virtual void chrono::vehicle::ChVehicleCosimOtherNode::Synchronize | ( | int | step_number,
|  | double | time )
| inlinefinaloverridevirtual

Synchronize this node.

Implements chrono::vehicle::ChVehicleCosimBaseNode.

The documentation for this class was generated from the following file:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/cosim/ChVehicleCosimOtherNode.h